/*******************************************************************************
 *
 * Pentaho Data Integration
 *
 * Copyright (C) 2002-2012 by Pentaho : http://www.pentaho.com
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ******************************************************************************/

package org.pentaho.di.core.spreadsheet;

public interface KCell {
  public KCellType getType();
  
  /**
   * @return 
   * java.util.Date for KCellType.DATE<br>
   * Boolean for KCellType.BOOLEAN<br>
   * Double for KCellType.NUMBER<br>
   * String for KCellType.LABEL<br>
   * null for KCellType.EMPTY<br>
   */
  public Object getValue();
  
  /**
   * @return The content description of the cell
   */
  public String getContents();
  
  /**
   * @return The row number in the sheet.
   */
  public int getRow();
}
