/*! ******************************************************************************
 *
 * Pentaho Data Integration
 *
 * Copyright (C) 2002-2013 by Pentaho : http://www.pentaho.com
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 ******************************************************************************/

package org.pentaho.di.core;

import java.util.ArrayList;
import java.util.List;

import org.pentaho.di.core.database.DatabaseMeta;
import org.pentaho.di.core.database.SAPR3DatabaseMeta;

public class ConstDB {
  /**
   * Select the SAP ERP databases in the List of databases.
   *
   * @param databases
   *          All the databases
   * @return SAP ERP databases in a List of databases.
   */
  public static final List<DatabaseMeta> selectSAPR3Databases( List<DatabaseMeta> databases ) {
    List<DatabaseMeta> sap = new ArrayList<DatabaseMeta>();

    for ( DatabaseMeta db : databases ) {
      if ( db.getDatabaseInterface() instanceof SAPR3DatabaseMeta ) {
        sap.add( db );
      }
    }

    return sap;
  }

}
